; doc$="blue.ico"
; ic=LoadImage_(GetModuleHandle_(0),@doc$,#IMAGE_ICON,16,16,#LR_LOADFROMFILE)
;Debug ic
Enumeration
  #width
  #height
  #canvas
  #btn_save
EndEnumeration

  If OpenWindow(0, 0, 0, 420, 420, "List Icons", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
    CanvasGadget(#canvas, 0, 0, 420, 400)
    SpinGadget(#width,0,400,40,20,1,14,#PB_Spin_Numeric)
    SpinGadget(#height,40,400,40,20,1,14,#PB_Spin_Numeric)
    ButtonGadget(#btn_save,90,400,40,20,"Save")
    EnableGadgetDrop(#canvas,#PB_Drop_Files,#PB_Drag_Copy)
    
    StartDrawing(CanvasOutput(#canvas))
    Box (0,0,420,400,0)
    DrawText(180,200,"Drag icons here",RGB(255,255,255),0)
    StopDrawing()
    
    SetGadgetState(#width,1)
    SetGadgetState(#height,1)
; StartDrawing(CanvasOutput(0))
; DrawImage(ic,0,0)
; StopDrawing()
    
    Repeat
      Event = WaitWindowEvent()
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
            Case #btn_save
              If IsImage(0)
                tosave$ = SaveFileRequester("Please choose file to save", GetCurrentDirectory(), "Bitmap (*.bmp)", 0)
                If tosave$
                  SaveImage(0,tosave$+".bmp")
                EndIf
              Else
                MessageRequester("Error!","Drag'n'Drop image first!",#PB_MessageRequester_Ok )
              EndIf
          EndSelect
          
        Case #PB_Event_GadgetDrop
          x=32*GetGadgetState(#width)
          y=32*GetGadgetState(#height)
          CreateImage(0,x,y)
          StartDrawing(ImageOutput(0))
          Box (0,0,x,y,RGB(255,255,255))
          Files$ = EventDropFiles()
          Count  = CountString(Files$, Chr(10)) + 1
          x=0
          y=0
          For ii = 1 To Count
            File$ = StringField(Files$, ii, Chr(10))
            ic=LoadImage_(GetModuleHandle_(0),@file$,#IMAGE_ICON,32,32,#LR_LOADFROMFILE)
            If ic
              DrawImage(ic,x*32,y*32)
            EndIf
            x=x+1
            If x=GetGadgetState(#width)
              x=0
              y+1
            EndIf
          Next ii
          StopDrawing()
          StartDrawing(CanvasOutput(#canvas))
          DrawImage(ImageID(0),0,0)
          StopDrawing()
          
      EndSelect
      
    Until Event = #PB_Event_CloseWindow
  EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 40
; FirstLine = 26
; EnableUnicode
; EnableXP
; Executable = iconlist.exe